function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { defineComponent, props, setup as _setup, $props, $prefix, $setup } from "@dftvue2-opentiny/vue-common";
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/steps/vue";
import { IconYes, IconChevronLeft, IconChevronRight } from "@dftvue2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import { renderless as renderless$1, api as api$1 } from "@dftvue2-opentiny/vue-renderless/steps/slide-bar";
var mode$2 = {
  tiny_mode: "mobile-first"
};
var __vue2_script$3 = defineComponent({
  emits: ["click"],
  components: {
    IconYes: IconYes(mode$2)
  },
  props: [].concat(props, ["vertical", "nameField", "statusField", "data", "active", "visibleNum", "descriptionField"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex text-color-text-primary",
    attrs: {
      "data-tag": "tiny-steps"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex !== 0,
      expression: "state.startIndex !== 0"
    }],
    class: ["flex-1 flex flex-col cursor-pointer", _vm.vertical ? "text-center" : "sm:max-w-[18.75rem] sm:mr-4"],
    attrs: {
      "data-tag": "tiny-steps-left"
    },
    on: {
      "click": function click($event) {
        _vm.state.startIndex--;
      }
    }
  }, [_c("div", {
    staticClass: "flex items-center relative",
    attrs: {
      "data-tag": "tiny-steps-main"
    }
  }, [_c("div", {
    class: ["border-t-0.5 border-color-text flex-auto opacity-0", {
      "sm:min-w-[1.5rem] sm:ml-4 sm:hidden": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  }), _c("div", {
    staticClass: "w-6 h-6 flex-none flex relative z-10",
    attrs: {
      "data-tag": "tiny-steps-icon"
    }
  }, [_c("div", {
    staticClass: "w-full h-full flex items-center justify-center rounded-full border-0.5 border-color-brand text-color-brand bg-white font-medium relative z-10"
  }, [_vm._v(" " + _vm._s(_vm.state.startIndex) + " ")]), _vm.state.startIndex - 1 > 0 ? _vm._l(_vm.state.startIndex - 1, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "w-6 h-6 flex-none rounded-full border-0.5 border-color-brand bg-white font-medium absolute",
      style: {
        right: (_vm.state.startIndex - 1 - index) * 4 + "px"
      }
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["border-t-0.5 border-color-text flex-auto", {
      "sm:min-w-[1.5rem] sm:ml-4": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  })])]), _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.isVisibleHandler(index) === "visible",
        expression: "isVisibleHandler(index) === 'visible'"
      }],
      key: index,
      class: _vm.m("group flex-1 flex flex-col cursor-pointer text-center", {
        "text-color-brand": index === _vm.active
      }, _vm.vertical ? "" : "sm:min-w-[8rem] sm:max-w-[18.75rem] sm:mr-4 sm:text-left", {
        "flex-none": index === _vm.data.length - 1
      }, {
        " hover:text-color-brand-hover active:text-color-brand-active": node[_vm.statusField] !== "disabled" && node[_vm.statusField] !== "error"
      }, {
        "text-color-none-hover": node[_vm.statusField] === "disabled"
      }, {
        "text-color-error": node[_vm.statusField] === "error"
      }),
      attrs: {
        "data-tag": "tiny-steps-block"
      },
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node, $event);
        }
      }
    }, [_c("div", {
      staticClass: "flex items-center",
      attrs: {
        "data-tag": "tiny-steps-main"
      }
    }, [_c("div", {
      class: ["border-t-0.5 border-color-text flex-auto", {
        "opacity-0": index === 0 && _vm.state.startIndex === 0
      }, {
        "sm:hidden sm:min-w-[1.5rem] sm:ml-4": !_vm.vertical
      }],
      attrs: {
        "data-tag": "tiny-steps-line"
      }
    }), _c("div", {
      class: _vm.m("w-6 h-6 flex-none flex items-center justify-center rounded-full border-0.5 border-current text-color-brand bg-white font-medium", {
        "bg-color-brand border-color-brand text-white": index === _vm.active
      }, {
        "text-color-none-hover": node[_vm.statusField] === "disabled"
      }, {
        "text-color-error ": node[_vm.statusField] === "error"
      }, {
        "bg-color-error border-color-error text-white": index === _vm.active && node[_vm.statusField] === "error"
      }, {
        "bg-color-none-hover border-color-none-hover text-white": index === _vm.active && node[_vm.statusField] === "disabled"
      }),
      attrs: {
        "data-tag": "tiny-steps-icon"
      }
    }, [node[_vm.statusField] === "done" ? [_c("IconYes", {
      class: _vm.m("w-4 h-4 fill-color-brand", {
        "fill-white": index === _vm.active
      })
    })] : node[_vm.statusField] === "error" ? [_vm._v(" ! ")] : [_vm._v(" " + _vm._s(index + 1) + " ")]], 2), !_vm.vertical ? _c("div", {
      class: _vm.m("hidden sm:block text-sm ml-2 font-medium truncate"),
      attrs: {
        "data-tag": "tiny-steps-title",
        "title": node[_vm.nameField]
      }
    }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]) : _vm._e(), _c("div", {
      class: _vm.m("border-t-0.5 border-color-text flex-auto", {
        "sm:hidden": !_vm.vertical && index === _vm.data.length - 1
      }, {
        "opacity-0": index === _vm.data.length - 1
      }, {
        "sm:min-w-[1.5rem] sm:ml-4": !_vm.vertical
      }),
      attrs: {
        "data-tag": "tiny-steps-line"
      }
    })]), _vm._t("item", function() {
      return [_c("div", {
        class: ["text-sm mt-3 font-medium truncate mx-5", {
          "sm:hidden sm:mx-0": !_vm.vertical
        }],
        attrs: {
          "data-tag": "tiny-steps-title",
          "title": node[_vm.nameField]
        }
      }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), node[_vm.descriptionField] ? _c("div", {
        class: _vm.m("text-xs text-color-text-secondary mt-2 line-clamp-2 mx-5", {
          "text-color-brand": index === _vm.active
        }, {
          "group-hover:text-color-brand-hover group-active:text-color-brand-active": node[_vm.statusField] !== "disabled" && node[_vm.statusField] !== "error"
        }, {
          "text-color-none-hover": node[_vm.statusField] === "disabled"
        }, {
          "text-color-error": node[_vm.statusField] === "error"
        }, !_vm.vertical ? "sm:ml-8" : ""),
        attrs: {
          "data-tag": "tiny-steps-description"
        }
      }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e()];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex + _vm.visibleNum < _vm.data.length,
      expression: "state.startIndex + visibleNum < data.length"
    }],
    class: ["flex-1 flex flex-col cursor-pointer text-center", {
      "sm:min-w-[8rem] sm:max-w-[18.75rem] sm:text-left": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-right"
    },
    on: {
      "click": function click($event) {
        _vm.state.startIndex++;
      }
    }
  }, [_c("div", {
    staticClass: "flex items-center relative",
    attrs: {
      "data-tag": "tiny-steps-main"
    }
  }, [_c("div", {
    class: ["border-t-0.5 border-color-text flex-auto", {
      "sm:hidden sm:min-w-[1.5rem] sm:ml-4": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  }), _c("div", {
    staticClass: "w-6 h-6 flex-none flex relative z-10",
    attrs: {
      "data-tag": "tiny-steps-icon"
    }
  }, [_c("div", {
    staticClass: "w-full h-full flex items-center justify-center rounded-full border-0.5 border-color-brand text-color-brand bg-white font-medium relative z-[9999]"
  }, [_vm._v(" " + _vm._s(_vm.state.endIndex + 1) + " ")]), _vm.state.rightNodePositions.length > 0 ? _vm._l(_vm.state.rightNodePositions, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "w-6 h-6 flex-none rounded-full border-0.5 border-color-brand bg-white font-medium absolute",
      style: item
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["border-t-0.5 border-color-text flex-auto opacity-0", {
      "sm:hidden sm:min-w-[1.5rem] sm:ml-4": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  })])])], 2);
};
var staticRenderFns$2 = [];
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$2, staticRenderFns$2, false, __vue2_injectStyles$3, null, null, null);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var MobileFirstTemplate = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var mode$1 = {
  tiny_mode: "mobile-first"
};
var __vue2_script$2 = defineComponent({
  emits: ["click"],
  components: {
    IconChevronLeft: IconChevronLeft(mode$1),
    IconChevronRight: IconChevronRight(mode$1)
  },
  props: _extends({}, $props, {
    data: Array,
    duration: {
      type: Number,
      default: 300
    },
    delay: {
      type: Number,
      default: 5
    },
    noArrow: Boolean,
    flex: Boolean
  }),
  setup: function setup2(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1
    });
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-full flex",
    attrs: {
      "data-tag": "tiny-steps-slide-bar"
    }
  }, [_c("div", {
    ref: "leftButton",
    class: ["hidden flex-none h-8 cursor-pointer items-center select-none", {
      "sm:flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }],
    attrs: {
      "data-tag": "left-button"
    },
    on: {
      "click": _vm.leftSlideHandler
    }
  }, [_vm._t("left-button", function() {
    return [_c("div", {
      staticClass: "w-4 h-full flex items-center justify-center mr-1.5 bg-color-bg-2"
    }, [_c("IconChevronLeft", {
      staticClass: "h-3 w-3"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canLeftScroll,
    "index": _vm.slideBarState.boundingIndex.left
  })], 2), _c("div", {
    ref: "slideMain",
    staticClass: "flex-auto overflow-auto scrollbar-size-0",
    attrs: {
      "data-tag": "slide-main"
    }
  }, [_c("div", {
    staticClass: "flex"
  }, _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      key: index,
      ref: "block" + index,
      refInFor: true,
      style: {
        width: _vm.flex ? 100 / _vm.data.length + "%" : null
      }
    }, [_vm._t("block", function() {
      return [_vm._v(_vm._s(index))];
    }, {
      "slotScoped": {
        node,
        index,
        show: index > _vm.slideBarState.boundingIndex.left && (_vm.slideBarState.boundingIndex.right === -1 || index < _vm.slideBarState.boundingIndex.right)
      }
    }), _vm._t("block-bottom", null, {
      "node": node,
      "index": index,
      "show": index > _vm.slideBarState.boundingIndex.left && (_vm.slideBarState.boundingIndex.right === -1 || index < _vm.slideBarState.boundingIndex.right)
    })], 2);
  }), 0)]), _c("div", {
    ref: "rightButton",
    class: ["hidden flex-none h-8 cursor-pointer items-center select-none", {
      "sm:flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }],
    attrs: {
      "data-tag": "right-button"
    },
    on: {
      "click": _vm.rightSlideHandler
    }
  }, [_vm._t("right-button", function() {
    return [_c("div", {
      staticClass: "w-4 h-full flex items-center justify-center ml-1.5 bg-color-bg-2"
    }, [_c("IconChevronRight", {
      staticClass: "h-3 w-3"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canRightScroll,
    "index": _vm.slideBarState.boundingIndex.right
  })], 2)]);
};
var staticRenderFns$1 = [];
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$1, staticRenderFns$1, false, __vue2_injectStyles$2, null, null, null);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var SlideBar = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var mode = {
  tiny_mode: "mobile-first"
};
var __vue2_script$1 = defineComponent({
  emits: ["click"],
  components: {
    SlideBar,
    IconYes: IconYes(mode),
    IconChevronLeft: IconChevronLeft(mode),
    IconChevronRight: IconChevronRight(mode)
  },
  props: [].concat(props, ["vertical", "nameField", "statusField", "data", "active", "visibleNum", "duration", "noArrow", "flex"]),
  setup: function setup3(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-full flex text-color-text text-xs leading-4",
    attrs: {
      "data-tag": "tiny-steps-advanced"
    }
  }, [_c("SlideBar", {
    ref: "slideBar",
    attrs: {
      "data": _vm.data,
      "duration": _vm.duration,
      "no-arrow": _vm.noArrow,
      "flex": _vm.flex
    },
    scopedSlots: _vm._u([{
      key: "left-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["w-4 h-full flex items-center justify-center mr-1.5", slotScoped.show ? "bg-color-bg-2 text-color-text hover:bg-color-info-secondary-subtle hover:text-color-brand" : "text-color-text-disabled bg-color-bg-2"]
        }, [_c("IconChevronLeft", {
          staticClass: "h-3 w-3 fill-current"
        })], 1)];
      }
    }, {
      key: "right-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["w-4 h-full flex items-center justify-center ml-1.5", slotScoped.show ? "bg-color-bg-2 text-color-text hover:bg-color-info-secondary-subtle hover:text-color-brand" : "text-color-text-disabled bg-color-bg-2"]
        }, [_c("IconChevronRight", {
          staticClass: "h-3 w-3 fill-current"
        })], 1)];
      }
    }, {
      key: "block",
      fn: function fn(_ref) {
        var _ref$slotScoped = _ref.slotScoped, node = _ref$slotScoped.node, index = _ref$slotScoped.index;
        return [_c("div", {
          class: _vm.m("h-8 flex rounded-sm relative cursor-pointer group", {
            "min-w-[7.5rem] max-w-[13.75rem]": !_vm.flex
          }, {
            "text-white": index === _vm.active
          }, {
            "text-color-error": node[_vm.statusField] === "error" && index !== _vm.active
          }, {
            "text-color-text-disabled": node[_vm.statusField] === "disabled" && index !== _vm.active
          }, {
            "bg-color-brand": index === _vm.active
          }, {
            "bg-color-bg-2": node[_vm.statusField] !== "error" && index !== _vm.active
          }, {
            "bg-color-error": node[_vm.statusField] === "error" && index === _vm.active
          }, {
            "hover:bg-color-error-hover hover:text-white": node[_vm.statusField] === "error"
          }, {
            "bg-color-info-secondary-subtle": node[_vm.statusField] === "done" && index !== _vm.active
          }, {
            "bg-color-error-subtler": node[_vm.statusField] === "error" && index !== _vm.active
          }),
          attrs: {
            "data-tag": "tiny-steps-block"
          },
          on: {
            "click": function click($event) {
              return _vm.$emit("click", index, node, $event);
            }
          }
        }, [_c("div", {
          class: ["flex-auto flex max-w-full items-center justify-center px-4 overflow-hidden h-full"],
          attrs: {
            "data-tag": "tiny-steps-content"
          }
        }, [_vm._t("item", function() {
          return [["done", "error"].indexOf(node[_vm.statusField]) !== -1 ? _c("div", {
            class: _vm.m("w-3.5 h-3.5 flex flex-none items-center justify-center rounded-full mr-2", index === _vm.active ? "bg-white text-color-brand" : "bg-color-brand text-white", {
              "text-white bg-color-error group-hover:bg-white group-hover:text-color-error": node[_vm.statusField] === "error"
            }, {
              "text-color-error bg-white": node[_vm.statusField] === "error" && index === _vm.active
            }),
            attrs: {
              "data-tag": "tiny-steps-icon"
            }
          }, [node[_vm.statusField] === "done" ? _c("IconYes", {
            class: ["w-2.5 h-2.5 fill-current"]
          }) : node[_vm.statusField] === "error" ? [_vm._v(" ! ")] : _vm._e()], 2) : _vm._e(), _c("div", {
            staticClass: "flex-none",
            attrs: {
              "data-tag": "tiny-steps-prefixslot"
            }
          }, [_vm._t("prefix", function() {
            return [_c("div", {
              staticClass: "-mr-2"
            })];
          }, {
            "slotScope": {
              node,
              index
            }
          })], 2), _c("div", {
            staticClass: "flex-auto max-w-full truncate",
            attrs: {
              "data-tag": "tiny-steps-text"
            }
          }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")])];
        }, {
          "slotScope": node,
          "index": index
        })], 2), _c("div", {
          class: ["h-full absolute left-0 top-0 border-t-[1rem] border-b-[1rem] border-l-[0.375rem]  border-t-transparent border-b-transparent border-white", {
            "hidden": index === 0
          }]
        }), _c("div", {
          class: ["h-full absolute right-0 top-0 border-t-[1rem] border-b-[1rem] border-l-[0.375rem]  border-l-transparent border-white", {
            "hidden": index === _vm.data.length - 1
          }]
        })])];
      }
    }, {
      key: "block-bottom",
      fn: function fn(_ref2) {
        var node = _ref2.node, index = _ref2.index, show = _ref2.show;
        return [show ? _vm._t("block-bottom", null, {
          "node": node,
          "index": index
        }) : _vm._e()];
      }
    }], null, true)
  })], 1);
};
var staticRenderFns = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render, staticRenderFns, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var MobileFirstAdvancedTemplate = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var template = function template2(mode2, props2) {
  return props2.advanced ? MobileFirstAdvancedTemplate : MobileFirstTemplate;
};
var __vue2_script = defineComponent({
  name: $prefix + "Steps",
  props: _extends({}, $props, {
    nameField: {
      type: String,
      default: "name"
    },
    countField: {
      type: String,
      default: "count"
    },
    statusField: {
      type: String,
      default: "status"
    },
    data: [Object, Array],
    space: Number,
    active: {
      type: Number,
      default: -1
    },
    visibleNum: {
      type: Number,
      default: 3
    },
    descriptionField: {
      type: String,
      default: "description"
    },
    vertical: Boolean,
    advanced: Boolean,
    duration: {
      type: Number,
      default: 300
    },
    noArrow: Boolean,
    flex: Boolean
  }),
  setup: function setup4(props2, context) {
    return $setup({
      props: props2,
      context,
      template
    });
  }
});
var __vue2_render, __vue2_staticRenderFns;
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, __vue2_render, __vue2_staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  mobileFirst as default
};
