import { renderless, api } from "@dftvue2-opentiny/vue-renderless/steps/vue";
import { defineComponent, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import { iconRefres, iconYes } from "@dftvue2-opentiny/vue-icon";
import "@dftvue2-opentiny/vue-theme/steps/index.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["click"],
  components: {
    IconRefres: iconRefres(),
    IconYes: iconYes()
  },
  props: [].concat(props, ["vertical", "showNumber", "nameField", "statusField", "countField", "start", "data", "space", "active", "reverse"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-steps"
  }, [_c("ul", {
    staticClass: "tiny-steps-advanced"
  }, _vm._l(_vm.data, function(node, index) {
    var _class;
    return _c("li", {
      key: index,
      class: (_class = {
        current: index === _vm.active
      }, _class[node[_vm.statusField]] = node[_vm.statusField], _class),
      style: {
        width: _vm.space ? _vm.state.computedSpace : 100 / _vm.data.length + "%"
      },
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node);
        }
      }
    }, [_vm._t("item", function() {
      return [_c("a", {
        staticClass: "label",
        attrs: {
          "title": node[_vm.nameField]
        }
      }, [_c("span", [_vm._v(_vm._s(node[_vm.nameField]))])]), node[_vm.countField] ? _c("div", {
        staticClass: "count"
      }, [_vm._v(" " + _vm._s(node[_vm.countField]) + " ")]) : _vm._e(), node[_vm.statusField] ? _c("div", {
        class: ["dot", node[_vm.statusField]]
      }, [node[_vm.statusField] === "doing" ? _c("icon-refres") : node[_vm.statusField] === "done" ? _c("icon-yes") : _vm._e()], 1) : _vm._e()];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), 0)]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
